      DOUBLE PRECISION FUNCTION MAP_STEEL_NEWF(TK,GM0,
     &PSI,THETA,ND,CD,XB)
      IMPLICIT NONE
      DOUBLE PRECISION CD(4), C1, C2, R, RR
      DOUBLE PRECISION BETA, TK, GM0, PSI, THETA, ND, XB
      DOUBLE PRECISION A, B, C, E, F, FST, FGB, FGC, GA
      DOUBLE PRECISION GAMMA, GM0, GB, GC, FHB, FHC, H, HA
      DOUBLE PRECISION HB, GNT, G, LHA, SND, GSM, LGA
C
      DOUBLE PRECISION MAP_STEEL_FUNCT
C
      PARAMETER (R=8.314D0,RR=2540D0)
C
      C1    = CD(1)
      BETA  = CD(2)*(1.0D0- CD(4)*XB)
      C2    = CD(3)
      GSM   = ND
      GNT   = 3.636*(TK-273.15) -2540D0
      A     = 1.0D0/(THETA*GSM*C1)
      B     = THETA*BETA
      GAMMA = C2*(GM0-GNT)/(RR*R*TK)
      C     = C2/(R*TK)+C2*GM0/(RR*R*TK)
      E     = GAMMA/B
      F     = A*(B+1.0D0)
      FST   = DEXP(C)/F
      GA    = 1.0D0+(B*PSI)
      IF (GA .LT. 0.0D0) THEN
         GA = -GA
      END IF
      LGA   = DLOG(GA)
      GB    = (GAMMA*PSI)-E
      FGB   = MAP_STEEL_FUNCT(GB)
      GC    = -E
      FGC   = MAP_STEEL_FUNCT(GC)
      G     = LGA+FGB-FGC
      HA    = 1.0D0-PSI
      LHA   = DLOG(HA)
      HB    = HA*GAMMA
      FHB   = MAP_STEEL_FUNCT(HB)
      FHC   = MAP_STEEL_FUNCT(GAMMA)
      H     = LHA+FHB-FHC
      SND   = G*DEXP(E)-H*DEXP(-GAMMA)
C
      MAP_STEEL_NEWF = FST*SND
C
      END
